#include <iostream>
#include <vector>

using namespace std;
using ll = long long;
vector<ll>gl1[200100];
ll gl2[200100];
vector<ll> g[200100];
void dfs(ll p, ll d, ll gl){
    gl2[p]=gl;
    for(auto i:g[p]){
        if(i!=d)dfs(i, p , gl+1);
    }
    gl1[gl].push_back(p);
}

ll pr[19][200100];

void dfs1(ll p, ll d, ll k){
    if(k==0){
        pr[k][p]=d;
    }else if(p!=1){
        pr[k][p]=pr[k-1][pr[k-1][p]];
    }
    for(auto i:g[p])if(i!=d){
            dfs1(i, p, k);
        }
}

ll LCA(ll a, ll b){
    if(a==b)return a;
    int i=18;
    while(a!=b){
        if(pr[i][a]!=pr[i][b]){
            a=pr[i][a];
            b=pr[i][b];
        }else{
            if(i==0){
                return pr[0][a];
            }
            i--;
        }
    }

    return a;
}

//LCA


void solve() {
    ll n, m, k=0, i;
    ll t;
    string str;
    cin >> n >> k >>t;
    for(i=1; i<n; i++){
        int x,y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    if(t==0){
        if(k==1){
            for(i=n; i>=0; i--){
                gl1[i].clear();gl2[i]=0;
            }
            dfs(1, -1, 0);
            for(i=0; i<19; i++){
                pr[i][1]=-1;
            }
            for(i=0; i<19; i++){
                dfs1(1, -1, i);
            }
            m=0;
            for(i=n; i>=0; i--){
                if(!gl1[i].empty()){
                    m=i;
                    break;
                }
            }
            t=gl1[m][0];
            for(i=1; i<gl1[m].size(); i++){
                t=LCA(t, gl1[m][i]);
            }
//            cout << m << ' ' << t << '\n';

            if(gl2[t]>=m/2){
                cout << (m+1)/2;
            }else{
                cout <<m-gl2[t];
            }

        }else cout << (n-1+k)/(k+1);
    }else{
        cout << (n-1+k)/(k+1) << '\n';
        for(i=2; i<=n-1; i++){
            ll l=0;
            ll r=n;
            while(r-l>1){
                ll m=(r+l)/2;
                if((i-1-1)/(m)+(n-i-1)/(m)<=k){
                    r=m;
                }else{
                    l=m;
                }
            }
            cout << r  << '\n';

        }
        cout << (n-1+k)/(k+1) <<'\n';
    }

}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}