#include <bits/stdc++.h>

using namespace std;
using ll = long long;
ll a[100100], L[100100], R[100100], l[100100], r[100100];
ll st[400100];
vector<ll>path[100100];


vector<ll> ans;

void dfs1(ll p) {
    if (a[p] == -1)ans.push_back(p);
    if (L[p]) {
        dfs1(L[p]);
    }

    if (a[p] == 0)ans.push_back(p);
    if (R[p]) {
        dfs1(R[p]);
    }
    if (a[p] == 1)ans.push_back(p);
}
ll dfs3(ll p, ll k) {
    if(p==k){
        if(a[k]==-1)return 1;
        else return 1+l[p]+r[p];
    }
    if (a[p] == -1 &&L[p])return 1+dfs3(L[p],k);
    if (a[p] == -1 &&R[p])return 1+dfs3(R[p],k);
    if (a[p] == 1 &&L[p])return dfs3(L[p],k);
    if (a[p] == 1 &&R[p])return dfs3(R[p],k);
}
void dfs(ll p) {
    path[p].push_back(p);
    if (L[p]) {
        path[L[p]]=path[p];
        dfs(L[p]);
        l[p]=1+l[L[p]]+r[L[p]];
    }

    if (R[p]) {
        path[R[p]]=path[p];
        dfs(R[p]);
        r[p]=1+l[R[p]]+r[R[p]];
    }
}

ll dfs2(ll p, ll k, ll ans, ll t) {
    if(k==p){
        if(a[p]==-1)return ans+1;
        else if(a[p]==0)return ans+l[p]+1;
        else return ans+r[p]+l[p]+1;
    }

    if (a[p] == -1)ans++;
    if (path[k][t+1]==L[p]) {
        return dfs2(L[p], k, ans, t+1);
    }else if(L[p])ans+=l[p];
    if (a[p] == 0)ans++;
    return dfs2(R[p], k, ans, t+1);
}

void build(ll v, ll tl, ll tr) {
    st[v] = -1;
}

void update(ll v, ll tl, ll tr, ll l, ll r, ll new_value) {
    if (l > r) {
        return;
    }
    if (tl == l && tr == r) {
        st[v] = new_value;
        return;
    }
    if (st[v] != -2) {
        st[v * 2] = st[v];
        st[v * 2 + 1] = st[v];
        st[v] = -2;
    }
    ll tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), new_value);
    update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, new_value);
}

ll get(ll v, ll tl, ll tr, ll pos) {
    if (tl == tr)return st[v];
    if (st[v] != -2)return st[v];
    ll tm = (tl + tr) / 2;
    if (tm < pos) {
        return get(v * 2 + 1, tm + 1, tr, pos);
    } else {
        return get(v * 2, tl, tm, pos);
    }
}
vector<pair<pair<ll,ll>, ll>>w;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n, q, j, i;
    cin >> n >> q;
    bool k2=true;
    for (i = 1; i <= n; i++) {
        cin >> L[i] >> R[i];
        if(L[i]+R[i]==2)k2=false;
        a[i] = -1;
    }
    dfs(1);
    bool k = true, k1=true;
    build(1, 1, n);
    if(k2)
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            ll l1, r1, value;
            cin >> l1 >> r1 >> value;
            if(value==0)k2=false;
            if(l1!=r1 && k1){
                k1=false;
                for(auto as:w)update(1, 1, n, as.first.first, as.first.second, as.second);
                w.clear();
            }else if(k1){
                k1=true;
                a[l1]=value;
                w.push_back({{l1,r1}, value});

            }
            if(!k1)update(1, 1, n, l1, r1, value);
            k = true;
        } else {
            cin >> i;
            if (k) {
                if(!k1){
                    for (j = 1; j <= n; j++)a[j] = get(1, 1, n, j);
                }
                if(k2){
                    cout << dfs3(1,i);
                    continue;
                }
                ans.clear();
                dfs1(1);
            }
            for (j = 0; j < ans.size(); j++)
                if (ans[j] == i) {
                    cout << j + 1 << '\n';
                    break;
                }
            k = false;

        }
    }
    return 0;
}