#include <bits/stdc++.h>

using namespace std;
using ll = long long;
ll a[100100], L[100100], R[100100];
ll st[400100];
vector<ll> ans;

void dfs1(ll p) {
    if (a[p] == -1)ans.push_back(p);
    if (L[p]) {
        dfs1(L[p]);
    }

    if (a[p] == 0)ans.push_back(p);
    if (R[p]) {
        dfs1(R[p]);
    }
    if (a[p] == 1)ans.push_back(p);
}

void build(ll v, ll tl, ll tr) {
    st[v] = -1;
}

void update(ll v, ll tl, ll tr, ll l, ll r, ll new_value) {
    if (l > r) {
        return;
    }
    if (tl == l && tr == r) {
        st[v] = new_value;
        return;
    }
    if (st[v] != -2) {
        st[v * 2] = st[v];
        st[v * 2 + 1] = st[v];
        st[v] = -2;
    }
    ll tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), new_value);
    update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, new_value);
}

ll get(ll v, ll tl, ll tr, ll pos) {
    if (tl == tr)return st[v];
    if (st[v] != -2)return st[v];
    ll tm = (tl + tr) / 2;
    if (tm < pos) {
        return get(v * 2 + 1, tm + 1, tr, pos);
    } else {
        return get(v * 2, tl, tm, pos);
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n, q, j, i;
    cin >> n >> q;
    for (i = 1; i <= n; i++) {
        cin >> L[i] >> R[i];
        a[i] = -1;
    }
    bool k = true;
    build(1, 1, n);
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            ll l1, r1, value;
            cin >> l1 >> r1 >> value;
            update(1, 1, n, l1, r1, value);
            k = true;
        } else {
            cin >> i;
            if (k) {
                for (j = 1; j <= n; j++)a[j] = get(1, 1, n, j);
                ans.clear();
                dfs1(1);
            }
            for (j = 0; j < ans.size(); j++)
                if (ans[j] == i) {
                    cout << j + 1 << '\n';
                    break;
                }
            k = false;

        }
    }
    return 0;
}